function CDebris (iX, iY, oParentContainer, iScale) {
    var _oDebris;
    var _iX = iX;
    var _iY = iY;
    var _oParentContainer = oParentContainer;
    var _iScale = iScale;
    
    this._init = function() {
        var oData = {   
                images: [s_oSpriteLibrary.getSprite("debris")], 
                framerate: 15,
                // width, height & registration point of each sprite
                frames: {width: 362, height: 612, regX: 362/2, regY: 612/2}, 
                animations: {idle:[0, 5]}
            };
        var oSpriteSheet = new createjs.SpriteSheet(oData);

        _oDebris= createSprite(oSpriteSheet, "idle", 362/2, 612/2, 362, 612);
        _oDebris.scaleX = _iScale;
        _oDebris.visible = false;
        _oDebris.x = _iX;
        _oDebris.y = _iY;
        _oDebris.on('animationend', this._destroyDebris );
        _oParentContainer.addChild(_oDebris);
    };

    this._destroyDebris = function() {
        _oDebris.visible = false;
    };

    this.restartAnimation = function() {
        _oDebris.visible = true;
        _oDebris.gotoAndPlay("idle");
    };
    
    var s_oDebris= this;

    this._init(iX, iY, oParentContainer);
};