function CAreYouSurePanel() {
    var _oButYes;
    var _oButNo;
    var _oFade;
    var _oPanelContainer;
    var _oParent;
    
    var _pStartPanelPos;

    this._init = function () {
        _oFade = new createjs.Shape();
        _oFade.graphics.beginFill("black").drawRect(0,0,CANVAS_WIDTH,CANVAS_HEIGHT);
        _oFade.alpha = 0.5;
        _oFade.on("mousedown",function(){});
        s_oStage.addChild(_oFade);
        
        new createjs.Tween.get(_oFade).to({alpha:0.7},500);
        
        _oPanelContainer = new createjs.Container();        
        s_oStage.addChild(_oPanelContainer);
        
        var oSprite = s_oSpriteLibrary.getSprite('msg_box');
        var oPanel = createBitmap(oSprite);  
        oPanel.regX = oSprite.width/2;
        oPanel.regY = oSprite.height/2;
        oPanel.x = CANVAS_WIDTH/2;
        oPanel.y = CANVAS_HEIGHT/2;
        _oPanelContainer.addChild(oPanel);

        _oPanelContainer.y = CANVAS_HEIGHT + oSprite.height/2;  
        _pStartPanelPos = {x: _oPanelContainer.x, y: _oPanelContainer.y};
        new createjs.Tween.get(_oPanelContainer).to({y:0},1000, createjs.Ease.backOut);

        var oTitleBack = new createjs.Text(TEXT_ARE_SURE," 60px "+PRIMARY_FONT, "#000000");
        oTitleBack.x = CANVAS_WIDTH/2 + 2;
        oTitleBack.y = CANVAS_HEIGHT/2 - 18;
        oTitleBack.textAlign = "center";
        oTitleBack.textBaseline = "middle";
        oTitleBack.lineWidth = 350;
        oTitleBack.outline = 3;
        _oPanelContainer.addChild(oTitleBack);

        var oTitle = new createjs.Text(TEXT_ARE_SURE," 60px "+PRIMARY_FONT, PRIMARY_FONT_COLOR);
        oTitle.x = CANVAS_WIDTH/2;
        oTitle.y = CANVAS_HEIGHT/2 - 20;
        oTitle.textAlign = "center";
        oTitle.textBaseline = "middle";
        oTitle.lineWidth = 350;
        _oPanelContainer.addChild(oTitle);

        _oButYes = new CGfxButton(CANVAS_WIDTH/2 + 100, CANVAS_HEIGHT/2 + 170, s_oSpriteLibrary.getSprite('but_yes'), _oPanelContainer);
        _oButYes.addEventListener(ON_MOUSE_UP, this._onButYes, this);

        _oButNo = new CGfxButton(CANVAS_WIDTH/2 - 100, CANVAS_HEIGHT/2 + 170, s_oSpriteLibrary.getSprite('but_no'), _oPanelContainer);
        _oButNo.addEventListener(ON_MOUSE_UP, this._onButNo, this);
    };

    this._onButYes = function () {
        _oButNo.disable();
        _oButYes.disable();
        
        new createjs.Tween.get(_oFade).to({alpha:0},500);
        new createjs.Tween.get(_oPanelContainer).to({y:_pStartPanelPos.y},400, createjs.Ease.backIn).call(function(){

            _oParent.unload();
            s_oGame.onExit();
            
        }); 
    };

    this._onButNo = function () {
        _oButNo.disable();
        _oButYes.disable();
        
        new createjs.Tween.get(_oFade).to({alpha:0},500);
        new createjs.Tween.get(_oPanelContainer).to({y:_pStartPanelPos.y},400, createjs.Ease.backIn).call(function(){
            _oParent.unload();
        }); 
        
        s_oGame.unpause();
    };

    this.unload = function () {
        _oButNo.unload();
        _oButYes.unload();
        
        s_oStage.removeChild(_oFade);
        s_oStage.removeChild(_oPanelContainer);

        _oFade.off("mousedown",function(){});
    };

    _oParent = this;
    this._init();
}

